
float scoreBox(NCCAPixmap srcFile, NCCAPixmap cmpFile)

{


  int   startX = 0, // Set start pixel
	startY = 0, 
	endX = ((2*SBOXTHICKNESS)+1),   // Set end pixel
	endY = ((2*SBOXTHICKNESS)+1),   
	currY, currX;		   // Current position (x,y)
  float scoreTotal = 0;	           // Error score	   
 
  NCCAPixel srcPixel,		   // Source pixel of first image
	    cmpPixel;  		   // Pixel to compare of second image


// ----------------------------------
// Loop to check and score pixels ...
// ----------------------------------



  for(currY = startY; currY <= endY; currY+=2) { 
    for(currX = startX; currX <= endX; currX++) {

     srcPixel = getPixel(srcFile, currX, currY);
     cmpPixel = getPixel(cmpFile, currX, currY);


// ----------------------------------------
// Sum the differences in colour values
// and store in "scoreTotal"
// ----------------------------------------


     scoreTotal = scoreTotal +
		  (abs(srcPixel.r - cmpPixel.r)) + 
		  (abs(srcPixel.g - cmpPixel.g)) +
		  (abs(srcPixel.b - cmpPixel.b));
    }
  }
  
  return scoreTotal;

}
