//********************************************************
//********************************************************
//Innovations Project - Steve Dawson - u9700985
//
//Conversion of point information into point/planar/camera
//
//At current position the program is incomplete and so can
//only be altered as source code, not as a program.
//
//to compile type,
//
//CC egomotion.cpp -lm
//
//
//********************************************************
//********************************************************

extern "C" {

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

}
#define SQR(X) ((X)*(X))
#define PI() 3.141592

#include <math.h>

typedef struct coord {
	int x;
	int y;
} COORD;


typedef struct coord3d {
	double x,y,z;

} COORD3D;
void main()
 {

   int totalFrames=50, i=1, currentFrame=1, iterNO;

// Set Viewing Distance and Distance of Points in inches
   float vd = 1;
   float d1=(3*1.3),
	 d2=(3*1);
	
	
// -------------------------------------------

   float pe0x,pe0y,pe0z = vd,pe1x,pe1y,pe1z = vd,pe2x,pe2y,pe2z = vd,t0,t1,t2,ll=0, ul=1000;
   float pw0x,pw0y,pw0z,pw1x,pw1y,pw1z,pw2x,pw2y,pw2z,
	 maxz,max1,max2, testValue = 0.0;

   COORD3D pw0, pw1, pw2;


   FILE *TLcoordFile, *TRcoordFile, *BRcoordFile, *OutputData;
   COORD TLcoord, TRcoord, BRcoord;

   TLcoordFile = fopen("topLeft2.dat", "r");
   TRcoordFile = fopen("topRight2.dat", "r");
   BRcoordFile = fopen("bottomRight2.dat", "r");

for(i=1; i<=totalFrames;i++){


	iterNO=0;

	printf("----------------------------FRAME : %d ---------------------------",i);
	fread(&TLcoord,sizeof(TLcoord),1,TLcoordFile);	
	fread(&TRcoord,sizeof(TRcoord),1,TRcoordFile);  
	fread(&BRcoord,sizeof(BRcoord),1,BRcoordFile);  

        pe0x = -1*(((float)TRcoord.x)-360.0)/720; 
        pe0y = -1*(((float)TRcoord.y)-288.0)/720;
        pe1x = -1*(((float)TLcoord.x)-360.0)/720;
        pe1y = -1*(((float)TLcoord.y)-288.0)/720;
        pe2x = -1*(((float)BRcoord.x)-360.0)/720;
        pe2y = -1*(((float)BRcoord.y)-288.0)/720;



	max1 = (d1*vd)/sqrt(SQR(pe0x)+SQR(pe0y)-2*pe0x*pe1x + SQR(pe1x) - 2*pe0y*pe1y + SQR(pe1y));

	max2 = (d2*vd)/sqrt(SQR(pe0x)+SQR(pe0y)-2*pe0x*pe2x + SQR(pe2x) - 2*pe0y*pe2y + SQR(pe2y));

	if (max1<max2) maxz=max1;
	else maxz=max2;









//-------------------------------------------------------------
//Blimey...
//-------------------------------------------------------------
//
//-------------------------------------------------------------
	pw0z = maxz;

	t0 = maxz/vd;
	

	t1 = (-1*(-2*pe0x*pe1x - 2*pe0y*pe1y - 2*pe0z*pe1z)*t0 +
		sqrt(
		  SQR(-2*pe0x*pe1x - 2*pe0y*pe1y - 2*pe0z*pe1z)
		  *SQR(t0)
		  -4*(SQR(pe1x)+SQR(pe1y)+SQR(pe1z))
		  *(-1*SQR(d1) + SQR(pe0x)*SQR(t0) + SQR(pe0y)*SQR(t0) + SQR(pe0z)*SQR(t0))
		)
	     )/(2*(SQR(pe1x)+SQR(pe1y)+SQR(pe1z)));

	t2 = (-1*(-2*pe0x*pe2x - 2*pe0y*pe2y - 2*pe0z*pe2z)*t0 +
		sqrt(
		  SQR(-2*pe0x*pe2x - 2*pe0y*pe2y - 2*pe0z*pe2z)
		  *SQR(t0)
		  -4*(SQR(pe2x)+SQR(pe2y)+SQR(pe2z))
		  *(-1*SQR(d2) + SQR(pe0x)*SQR(t0) + SQR(pe0y)*SQR(t0) + SQR(pe0z)*SQR(t0))
		)
	     )/(2*(SQR(pe2x)+SQR(pe2y)+SQR(pe2z)));








//----------------------------------------------------
//From that resolve the rest of the 3d Coordinates.

        pw0x = (t0*pe0x);
        pw0y = (t0*pe0y);

        pw1x = (t1*pe1x);
        pw1y = (t1*pe1y);
        pw1z = (t1*pe1z);

        pw2x = (t2*pe2x);
        pw2y = (t2*pe2y);
        pw2z = (t2*pe2z);




//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
/*
pw0.x=(double)pw0x;
pw0.y=(double)pw0y;
pw0.z=(double)pw0z;
pw1.x=(double)pw1x;
pw1.y=(double)pw1y;
pw1.z=(double)pw1z;
pw2.x=(double)pw2x;
pw2.y=(double)pw2y;
pw2.z=(double)pw2z;
   OutputData = fopen("DataTest.dat", "w");
       fwrite(&pw0.x,sizeof(pw0.x),1,OutputData);
       fwrite(&pw0.y,sizeof(pw0.y),1,OutputData);
       fwrite(&pw0.z,sizeof(pw0.z),1,OutputData);

       fwrite(&pw1.x,sizeof(pw1.x),1,OutputData);
       fwrite(&pw1.y,sizeof(pw1.y),1,OutputData);
       fwrite(&pw1.z,sizeof(pw1.z),1,OutputData);

       fwrite(&pw2.x,sizeof(pw2.x),1,OutputData);
       fwrite(&pw2.y,sizeof(pw2.y),1,OutputData);
       fwrite(&pw2.z,sizeof(pw2.z),1,OutputData);
   fclose(OutputData);
*/
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------
//----------------------------------------------------------


//	a = sqrt(SQR(pw2x-pw1x)+SQR(pw2y-pw1y)+SQR(pw2z-pw1z));
//	b = sqrt(SQR(pw0x-pw2x)+SQR(pw0y-pw2y)+SQR(pw0z-pw2z));
//	c = sqrt(SQR(pw0x-pw1x)+SQR(pw0y-pw1y)+SQR(pw0z-pw1z));

	testValue = (((pw0x-pw1x)*(pw0x-pw2x))+((pw0y-pw1y)*(pw0y-pw2y))+((pw0z-pw1z)*(pw0z-pw2z)));

//	testValue = facos(((SQR(c)-SQR(a)-SQR(b))/(-2*a*b))*(PI()/180));



//	




if(testValue<0){

//-------------------------------------
//***********  WHILE LOOP  ************
//-------------------------------------


	while( (int)(testValue*100) != 0 ){



//------------------------------------
//Main Iteration Part		
//------------------------------------
	if(iterNO==0){
		ll=0; ul=t0; t0=(t0/2);//	
		}
	else{
	  if(testValue>0){				//t0 needs to be greater
	   ll = t0;
	   t0 = ll+((ul-ll)/2);//	
	}

	  if(testValue<0){				//t0 needs to be smaller
	   ul = t0;
	   t0 = ll+((ul-ll)/2);//	
	}

	  if((testValue)==0){
	   t0 = t0; }
	}

//-------------------------------------
//-------------------------------------
//The equations for t1 and t2
//-------------------------------------

	 


 	t1 = (-1*(-2*pe0x*pe1x - 2*pe0y*pe1y - 2*pe0z*pe1z)*t0 +
		sqrt(
		  SQR(-2*pe0x*pe1x - 2*pe0y*pe1y - 2*pe0z*pe1z)
		  *SQR(t0)
		  -4*(SQR(pe1x)+SQR(pe1y)+SQR(pe1z))
		  *(-1*SQR(d1) + SQR(pe0x)*SQR(t0) + SQR(pe0y)*SQR(t0) + SQR(pe0z)*SQR(t0))
		)
	     )/(2*(SQR(pe1x)+SQR(pe1y)+SQR(pe1z)));

	t2 = (-1*(-2*pe0x*pe2x - 2*pe0y*pe2y - 2*pe0z*pe2z)*t0 +
		sqrt(
		  SQR(-2*pe0x*pe2x - 2*pe0y*pe2y - 2*pe0z*pe2z)
		  *SQR(t0)
		  -4*(SQR(pe2x)+SQR(pe2y)+SQR(pe2z))
		  *(-1*SQR(d2) + SQR(pe0x)*SQR(t0) + SQR(pe0y)*SQR(t0) + SQR(pe0z)*SQR(t0))
		)
	     )/(2*(SQR(pe2x)+SQR(pe2y)+SQR(pe2z)));



        pw0x = (t0*pe0x);
        pw0y = (t0*pe0y);
        pw0z = (t0*pe0z);

        pw1x = (t1*pe1x);
        pw1y = (t1*pe1y);
        pw1z = (t1*pe1z);

        pw2x = (t2*pe2x);
        pw2y = (t2*pe2y);
        pw2z = (t2*pe2z);


	testValue = (((pw1x-pw0x)*(pw2x-pw0x))+((pw1y-pw0y)*(pw2y-pw0y))+((pw1z-pw0z)*(pw2z-pw0z)));


//	a = sqrt(SQR(pw2x-pw1x)+SQR(pw2y-pw1y)+SQR(pw2z-pw1z));
//	b = sqrt(SQR(pw0x-pw2x)+SQR(pw0y-pw2y)+SQR(pw0z-pw2z));
//	c = sqrt(SQR(pw0x-pw1x)+SQR(pw0y-pw1y)+SQR(pw0z-pw1z));

//	testValue = facos(((SQR(c)-SQR(a)-SQR(b))/(-2*a*b))*(PI()/180));







//Debug Value



if(iterNO==50)	testValue = 0;
iterNO++;





}
}


//-----------------------------------------------
//************ Convert to Rotation **************
//-----------------------------------------------

COORD3D R;
R.x = (-1*atan((pw2z-pw0z)/(pw0y-pw2y))*(180/PI()));
R.y = (-1*atan((pw1z-pw0z)/(pw1x-pw0x))*(180/PI()));
R.z = (-1*atan((pw0y-pw1y)/(pw1x-pw0x))*(180/PI()));




//-----------------------------------------------
//-----------------------------------------------
//******* Saving Out Plane Information **********
//-----------------------------------------------
pw0.x=(double)pw0x;
pw0.y=(double)pw0y;
pw0.z=(double)pw0z;

if(i==1)
  OutputData = fopen("DataTest.dat", "w");
else
  OutputData = fopen("DataTest.dat", "a");
       fwrite(&pw0.x,sizeof(pw0.x),1,OutputData);
       fwrite(&pw0.y,sizeof(pw0.y),1,OutputData);
       fwrite(&pw0.z,sizeof(pw0.z),1,OutputData);

       fwrite(&R.x,sizeof(R.x),1,OutputData);
       fwrite(&R.y,sizeof(R.y),1,OutputData);
       fwrite(&R.z,sizeof(R.z),1,OutputData);


   fclose(OutputData);
//-----------------------------------------------
//-----------------------------------------------



//-----------------------------------------------
//******* Saving Out Point Information **********
//-----------------------------------------------
//printf("p0=(%f,%f,%f) ", pw0x, pw0y, pw0z);
//printf("p1=(%f,%f,%f) ", pw1x, pw1y, pw1z);
//printf("p2=(%f,%f,%f)\n", pw2x, pw2y, pw2z);
//pw0.x=(double)pw0x;
//pw0.y=(double)pw0y;
//pw0.z=(double)pw0z;
//
//pw1.x=(double)pw1x;
//pw1.y=(double)pw1y;
//pw1.z=(double)pw1z;
//
//pw2.x=(double)pw2x;
//pw2.y=(double)pw2y;
//pw2.z=(double)pw2z;
//
//if(i==1)
//  OutputData = fopen("DataTest.dat", "w");
//else
//   OutputData = fopen("DataTest.dat", "a");
//       fwrite(&pw0.x,sizeof(pw0.x),1,OutputData);
//       fwrite(&pw0.y,sizeof(pw0.y),1,OutputData);
//       fwrite(&pw0.z,sizeof(pw0.z),1,OutputData);
//
//       fwrite(&pw1.x,sizeof(pw1.x),1,OutputData);
//       fwrite(&pw1.y,sizeof(pw1.y),1,OutputData);
//       fwrite(&pw1.z,sizeof(pw1.z),1,OutputData);
//
//       fwrite(&pw2.x,sizeof(pw2.x),1,OutputData);
//       fwrite(&pw2.y,sizeof(pw2.y),1,OutputData);
//       fwrite(&pw2.z,sizeof(pw2.z),1,OutputData);
//   fclose(OutputData);
//-----------------------------------------------
//-----------------------------------------------




}

  fclose(TLcoordFile);
  fclose(TRcoordFile);
  fclose(BRcoordFile);

	}

   
