
NCCAPixmap drawBox(NCCAPixmap inputFile, int x, int y, int thickness)

{


  int   startX = x-thickness, // Set start pixel
	startY = y-thickness, 
	endX = x+thickness,   // Set end pixel
	endY = y+thickness,   
	currY, currX;		   // Current position (x,y)  
 
  NCCAPixel srcPixel;		   


  for(currY = startY; currY <= endY; currY++) { 
    for(currX = startX; currX <= endX; currX++) {

     srcPixel = getPixel(inputFile, currX, currY);
     srcPixel.g = 100;
     srcPixel.b = 100;
     setPixelColour(inputFile, currX , currY , srcPixel);
    }
  }


  for(currY = startY; currY <= endY; currY+=2) { 
    for(currX = startX; currX <= endX; currX++) {

     srcPixel = getPixel(inputFile, currX, currY);
     srcPixel.g = 0;
     srcPixel.b = 0;
     setPixelColour(inputFile, currX , currY , srcPixel);
    }
  }
  
  return inputFile;

}
