
// ---------------------------
// Make a copy of the pattern 
// ---------------------------


NCCAPixmap copybox(NCCAPixmap srcImg, int x, int y)
{


 NCCAPixmap 	newMap;
 NCCAPixel	currentPixel;
 int startx = (x - SBOXTHICKNESS),
     starty = (y - SBOXTHICKNESS),
     endx = (x + SBOXTHICKNESS),
     endy = (y + SBOXTHICKNESS),
     currX, currY;



 newMap = (newPixmap ( (endx-startx+1) , (endy-starty+1) , srcImg.spp));


 for(currY = starty; currY <= endy; currY++) { 
   for(currX = startx; currX <= endx; currX++) {
 

   currentPixel = getPixel(srcImg, currX, currY);


   setPixelColour(newMap, (currX-startx) , (currY-starty) , currentPixel);

//  printf("(%d,%d)(%d,%d) =
// (%f,%f,%f)\n",currX,currY,x,y,currentPixel.r,currentPixel.g,currentPixel.b);

    }
  }

  return newMap;

}











COORD searchTrackBox(NCCAPixmap pattern, NCCAPixmap cmpFile, int x, int y)
{

  printf(".");
  int   startX = x - BBOXTHICKNESS, // Set start pixel on large picture
	startY = y - BBOXTHICKNESS, 
	endX = x + BBOXTHICKNESS,   // Set end pixel on large picture
	endY = y + BBOXTHICKNESS,   
	currY, currX;		   // Current position (x,y)
//	bestMatchX = 0,bestMatchY = 0,    // Best match position
  float currScore,bestScore = 1000000000.0; // Current and closest score to 0
  COORD finalCoord;


   NCCAPixmap   cmpPatternMap;



    
// -------------------------
// Loop to search each match
// -------------------------

  for(currY = 0; currY <= (endY-startY+1); currY+=2) { 
    for(currX = 0; currX <= (endX-startX+1); currX++) {




  cmpPatternMap = copybox(cmpFile, (startX+currX), (startY+currY));

  

// ----------------------
// Get score for matching
// ----------------------

  currScore = scoreBox(pattern, cmpPatternMap); //Score the image


// Set closest score to 0 as 'bestScore' and store (x,y)

  if (currScore < bestScore) {
	bestScore = currScore;
        //printf("(%d,%d)",startX+currX,startY+currY);
	finalCoord.x=currX+startX;
	finalCoord.y=currY+startY;
	}
   

    }
  }


 return finalCoord; 
}
